<?php

namespace Drupal\permanent_entities;

use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;

/**
 * Access controller for the Permanent Entity types.
 *
 * @see \Drupal\permanent_entities\Entity\PermanentEntityType.
 */
class PermanentEntityTypeAccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    /** @var \Drupal\permanent_entities\Entity\PermanentEntityTypeInterface $entity */
    if ($operation === 'delete') {
      $query = \Drupal::entityQuery('permanent_entity');
      $ids = $query->condition('type', $entity->id())->execute();

      if (!empty($ids)) {
        // Prevent deleting the bundle if there are instances of it created.
        return AccessResult::forbidden()->addCacheableDependency($entity);
      }
    }

    return parent::checkAccess($entity, $operation, $account);
  }

}
